/*
 * Copyright (C) 2002 Ichiro Satoh (ichiro@nii.ac.jp)
 */

package sample;

import tinyrmi.Message;
import tinyrmi.ORBServer;
import tinyrmi.ObjectId;

public class CalculatorClient {
	public static void main(String[] args) throws Exception {
    if (args.length != 3) {
      System.err.println(
			"java CalculatorClient <hostname> <remote_port> <local_port>");
      System.exit(-1);
    }
		int remote_port = Integer.parseInt(args[1]);
		int local_port = Integer.parseInt(args[2]);
    String host = args[0];
		ORBServer orb = new ORBServer(local_port);
		Message msg = new Message("sample.RemoteCalculator");
		ObjectId oid = orb.newInstance(host, remote_port, msg);
		Message add = new Message("add");
		add.setArg(3);
		add.setArg(4);
		System.out.println("3+4 = "+orb.invoke(host, remote_port, oid, add));
		Message mul = new Message("mul");
		mul.setArg(3);
		mul.setArg(4);
		System.out.println("3*4 = "+orb.invoke(host, remote_port, oid, mul));
  }
}
