/*
 * Copyright (C) 2002 Ichiro Satoh (ichiro@nii.ac.jp)
 */

package sample;

import tinyrmi.Message;
import tinyrmi.ORBServer;
import tinyrmi.ObjectId;

public class HelloWorldClient {
	public static void main(String[] args) throws Exception {
    if (args.length != 3) {
      System.err.println(
			"java HelloWorldClient <hostname> <remote_port> <local_port>");
      System.exit(-1);
    }
		int remote_port = Integer.parseInt(args[1]);
		int local_port = Integer.parseInt(args[2]);
    String host = args[0];
		ORBServer orb = new ORBServer(local_port);
		Message msg = new Message("sample.HelloWorldServer");
		ObjectId oid = orb.newInstance(host, remote_port, msg);
		Message print = new Message("print");
		print.setArg("Hello World");
		orb.invoke(host, remote_port, oid, print);
  }
}
