/*
 * Copyright (C) 2003 Ichiro Satoh (ichiro@nii.ac.jp)
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting
 * documentation.
 *
 * FREE USE OF THIS SOFTWARE IS ALLOWED IN ITS "AS IS" CONDITION.
 * BUT WITHOUT WARRANTY. THE AUTHORS DISCLAIM ANY LIABILITY OF ANY 
 * KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS 
 * SOFTWARE.
 */

package sample;

public class RemoteCalculator {
  int memory = 0;

  public synchronized Integer inc(int x) {
		int result = x + 1;
    System.out.println("RemoteCalculatorServer> "+result);
    return new Integer(result);
  }

  public synchronized Integer dec(int x) {
		int result = x + 1;
    System.out.println("RemoteCalculatorServer> "+result);
    return new Integer(result);
  }

  public synchronized Integer add(int x, int y) {
		int result = x + y;
    System.out.println("RemoteCalculatorServer> "+result);
    return new Integer(result);
  }

  public synchronized Integer sub(int x, int y) {
    int result = x - y;
    System.out.println("RemoteCalculatorServer> "+result);
    return new Integer(result);
  }

  public synchronized Integer mul(int x, int y) {
    int result = x * y;
    System.out.println("RemoteCalculatorServer> "+result);
    return new Integer(result);
  }

  public synchronized Integer div(int x, int y) {
    int result = x / y;
    System.out.println("RemoteCalculatorServer> "+result);
    return new Integer(result);
  }

  public synchronized Integer save(int x) {
    memory = x;
    System.out.println("RemoteCalculatorServer> "+memory);
    return new Integer(memory);
  }

  public synchronized Integer load() {
    System.out.println("RemoteCalculatorServer> "+memory);
    return new Integer(memory);
  }
}
