/*
 * Copyright (C) 2003 Ichiro Satoh (ichiro@nii.ac.jp)
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting
 * documentation.
 *
 * FREE USE OF THIS SOFTWARE IS ALLOWED IN ITS "AS IS" CONDITION.
 * BUT WITHOUT WARRANTY. THE AUTHORS DISCLAIM ANY LIABILITY OF ANY 
 * KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS 
 * SOFTWARE.
 */

package sample;
import tinyrmi.Message;
import tinyrmi.ObjectId;
import tinyrmi.ORBServer;
import tinyrmi.RemoteException;

public class RemoteWindow {
	public static void main(String[] args) throws Exception {
		System.out.println("EndPoint: args.length " + args.length);
		int remote_port = Integer.parseInt(args[1]);
		int local_port = Integer.parseInt(args[2]);
		try {
	   	ORBServer orb = new ORBServer(local_port);
		  Message msg1 = new Message("java.awt.Frame");
	    ObjectId oid = orb.newInstance(args[0], remote_port, msg1);
	    System.out.println("EndPoint: oid = " + oid);
	    Message msg2 = new Message(oid, "add");
	    msg2.setArg(new java.awt.Button("OK"));
	    orb.invoke(args[0], remote_port, oid, msg2);
	    Message msg3 = new Message(oid, "pack");
	    orb.invoke(args[0], remote_port, oid, msg3);
	    Message msg4 = new Message(oid, "show");
	    orb.invoke(args[0], remote_port, oid, msg4);
		}
		catch (RemoteException e) {
	    	e.printStackTrace();
		}
	}
}

