/*
 * Copyright (C) 2003 Ichiro Satoh (ichiro@nii.ac.jp)
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting
 * documentation.
 *
 * FREE USE OF THIS SOFTWARE IS ALLOWED IN ITS "AS IS" CONDITION.
 * BUT WITHOUT WARRANTY. THE AUTHORS DISCLAIM ANY LIABILITY OF ANY 
 * KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS 
 * SOFTWARE.
 */

package sample;

import java.awt.Frame;
import java.awt.Panel;
import java.awt.Button;
import java.awt.TextArea;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import tinyrmi.Message;
import tinyrmi.ObjectId;
import tinyrmi.ORBServer;
import tinyrmi.RemoteException;

public class WindowSender extends Frame implements ActionListener {
	Panel panel;
	Button sendButton;
	TextArea area;
	ORBServer orb;
	ObjectId oid;
	String host;
	int remote_port;
	int local_port;

	public static void main(String[] args) throws Exception {
		int remote_port = Integer.parseInt(args[1]);
		int local_port = Integer.parseInt(args[2]);
		WindowSender sender = new WindowSender(args[0], remote_port, local_port);
	}

	public WindowSender(String host, int remote_port, int local_port) {
		super("Receiver Window");
		this.host = host;
		this.remote_port = remote_port;
		this.local_port = local_port;
		setSize(500,300);
		setLayout(new BorderLayout());
		panel = new Panel();
		panel.setLayout(new FlowLayout());
		panel.setSize(480, 260);
		area = new TextArea();
		panel.add(area);
		sendButton = new Button("SEND");
		sendButton.setActionCommand("SEND");
    sendButton.addActionListener((ActionListener)this);
		add(sendButton, BorderLayout.SOUTH);
		add(panel, BorderLayout.CENTER);
		setVisible(true);
		try {
			orb = new ORBServer(local_port);
		  Message msg = new Message("sample.WindowReceiver");
	    oid = orb.newInstance(host, remote_port, msg);
			System.out.println("starting client...");
		}
		catch (IOException e) {
	    	e.printStackTrace();
		}
	}
	
  public void actionPerformed(ActionEvent evt) {
    String action = evt.getActionCommand();
		if (action.equals("SEND")) {
			System.out.println("WindowSender: actionPerformed("+action+")");
			send(area);
			try {
				Message msg = new Message(oid, "add");
				msg.setArg(area);
				orb.invoke(host, remote_port, oid, msg);
			}
			catch (RemoteException e) {
	    	e.printStackTrace();
			}
		}
	}

	private void send(Component comp) {
		panel.remove(comp);
		setVisible(true);
	}
}
	

