/*
 * Copyright (C) 2003 Ichiro Satoh (ichiro@nii.ac.jp)
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting 
 * documentation.
 *
 * FREE USE OF THIS SOFTWARE IS ALLOWED IN ITS "AS IS" CONDITION.
 * BUT WITHOUT WARRANTY. THE AUTHORS DISCLAIM ANY LIABILITY OF ANY 
 * KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS 
 * SOFTWARE.
 */

package tinyrmi;

import java.io.IOException;
import tinyrmi.network.EndPoint;

public class ORBServer {
	EndPoint ep;
	public ORBServer(int port) throws IOException {
		System.out.println("ORBServer: Starting.... (port:"+port+")");
		ep = new EndPoint(port, true);
	}
	
	public ObjectId newInstance(String host, int port, Message msg)
		throws RemoteException {
		try {
			return ep.newInstance(host, port, msg);
		}
		catch (IOException e) {
			throw new RemoteException(e.getMessage());
		}
		catch (Exception e) {
			throw new RemoteException(e.getMessage());
		}
	}
	
	public Object invoke(String host, int port, ObjectId oid, Message msg)
		throws RemoteException {
		try {
			return ep.invoke(host, port, oid, msg);
		}
		catch (IOException e) {
			throw new RemoteException(e.getMessage());
		}
		catch (Exception e) {
			throw new RemoteException(e.getMessage());
		}
	}
	
	public static void main(String[] args) throws Exception {
		int port = 80;
		if (args.length == 1) {
			port = Integer.parseInt(args[0]);
		}
		try {
			new ORBServer(port);
		}
		catch(IOException e) {
			e.printStackTrace();
		}
	}
}
