/*
 * Copyright (C) 2003 Ichiro Satoh (ichiro@nii.ac.jp)
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting
 * documentation.
 *
 * FREE USE OF THIS SOFTWARE IS ALLOWED IN ITS "AS IS" CONDITION.
 * BUT WITHOUT WARRANTY. THE AUTHORS DISCLAIM ANY LIABILITY OF ANY 
 * KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS 
 * SOFTWARE.
 */
 
package tinyrmi;
import java.io.Serializable;

public class RemoteException
	extends java.io.IOException
	implements Serializable {

	public Throwable detail;

	public RemoteException() {}

	public RemoteException(String s) {
		super(s);
	}

	public RemoteException(String s, Throwable ex) {
		super(s);
		detail = ex;
	}

	public String getMessage() {
		if (detail == null) {
			return super.getMessage();
		}
		else {
			return super.getMessage()
				+ "; nested exception is: \n\t"
				+ detail.toString();
		}
	}
}
