/*
 * Copyright (C) 2003 Ichiro Satoh (ichiro@nii.ac.jp)
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting
 * documentation.
 *
 * FREE USE OF THIS SOFTWARE IS ALLOWED IN ITS "AS IS" CONDITION.
 * BUT WITHOUT WARRANTY. THE AUTHORS DISCLAIM ANY LIABILITY OF ANY 
 * KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS 
 * SOFTWARE.
 */
 
package tinyrmi.runtime;

//import rmi.ObjectID;
import tinyrmi.AlreadyBoundException;
import tinyrmi.Message;
import tinyrmi.NotBoundException;
import tinyrmi.runtime.loader.InvocationException;

public interface Runtime {
  public Object newInstance(Message msg) 
    throws AlreadyBoundException, InstantiationException, ClassNotFoundException;
  public Object invoke(Message msg) 
    throws NotBoundException, NoSuchMethodException, InvocationException;
  public void destroy();
  public ClassLoader getClassLoader();
  public Object addListener(Message msg) 
    throws NotBoundException, InvocationException;
}
