/*
 * Copyright (C) 2003 Ichiro Satoh (ichiro@nii.ac.jp)
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting
 * documentation.
 *
 * FREE USE OF THIS SOFTWARE IS ALLOWED IN ITS "AS IS" CONDITION.
 * BUT WITHOUT WARRANTY. THE AUTHORS DISCLAIM ANY LIABILITY OF ANY 
 * KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS 
 * SOFTWARE.
 */
 
package tinyrmi.runtime.loader;

import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectStreamClass;
import java.io.IOException;
import java.io.StreamCorruptedException;

class MarshalInputStream extends ObjectInputStream {
  ClassLoader loader = null;

  /**
   * Create a new MarshalInputStream object.
   */
  public MarshalInputStream(InputStream in, ClassLoader loader)
  throws IOException, StreamCorruptedException {	      
    super(in);
    this.loader = loader;
    enableResolveObject(true);
  }
  
  /**
   * Create a new MarshalInputStream object.
   */
  public MarshalInputStream(InputStream in)
  throws IOException, StreamCorruptedException {	      
    super(in);
  }
  
  protected Class resolveClass(ObjectStreamClass classDesc)
  throws IOException, ClassNotFoundException {
    String className = classDesc.getName();
    return loader.loadClass(className);
  }
}
