/*
 * Copyright (C) 2003 Ichiro Satoh (ichiro@nii.ac.jp)
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the
 * copyright notice and this permission notice appear in all copies of
 * the software, derivative works or modified versions, and any
 * portions thereof, and that both notices appear in supporting
 * documentation.
 *
 * FREE USE OF THIS SOFTWARE IS ALLOWED IN ITS "AS IS" CONDITION.
 * BUT WITHOUT WARRANTY. THE AUTHORS DISCLAIM ANY LIABILITY OF ANY 
 * KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS 
 * SOFTWARE.
 */
 
package tinyrmi.runtime.loader;

import java.io.OutputStream;
import java.io.ObjectOutputStream;
import java.io.IOException;

class MarshalOutputStream extends ObjectOutputStream {
  /**
   * Create a marshaling stream to handle RMI marshaling
   */
  public MarshalOutputStream(OutputStream out) 
  throws IOException {
    super(out);
    enableReplaceObject(true);
  }
  
  protected void annotateClass(Class cl) throws IOException {
    super.annotateClass(cl);
  }
}
